#include <bits/stdc++.h>
//#pragma GCC optimize("O3")
//#pragma GCC optimize("avx2")

using namespace std;
#define int long long

int n;
__int128 m;
vector<int> a, t;

__int128 sum(int i, int time) {
    if (time < a[i]) {
        return 0;
    } else if (time < a[i]+t[i]) {
        return 1;
    } else {
        int sdvig = ((time - a[i] - t[i]) + 1);
        if (sdvig >= 32) {
            return INT32_MAX;
        }
        return 1 << sdvig;
    }
}

__int128 overall_sum(int tm) {
    __int128 sm = 0;
    for (int i = 0; i < n; ++i) {
        sm += sum(i, tm);
    }
    return sm;
}

void solve() {
    cin >> n;
    int proto_m;
    cin >> proto_m;
    m = proto_m;

    a = vector<int>(n);
    t = vector<int>(n);

    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> t[i];
    }

    int l = 0, r = 1000000000;
    while (r - l > 1) {
        int mid = (r+l)/2;
        __int128 sm = overall_sum(mid);
        if (sm < m) {
            l = mid;
        } else {
            r = mid;
        }
    }
    /*while (l > 1 && overall_sum(l-1) == m) {
        l--;
    }*/

    if (overall_sum(r) == m) {
        cout << r;
    } else {
        cout << -1;
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    solve();
    return 0;
}

/*
4 11
3 5 1 10
2 9 2 13

13 124
5 6 8 8 1 6 4 6 4 7 10 3 9
5 2 10 5 2 1 1 4 8 3 4 1 9

5 3
1 10
2 20
3 30
4 40
5 50

 5 3
 1 2 3 4 5
 10 20 30 40 50

10 7
1 2 3 4 5 6 7 8 9 10
1 1 1 1 1 1 1 1 1 1
 */